using System;

using TeleVox_TeleToken;
using ExCommon;

namespace ExCommon
{
	public class Epilog
	{
		public Epilog()
		{
		}

		static public void Run()
		{
			// zamknicie sesji
			Console.Write("Zamkniecie sesji:");
			ZeroMem.ZeroMemory(ref MainDef.OutDataA, 16);
			ZeroMem.ZeroMemory(ref MainDef.OutDataB, 16);
			ZeroMem.ZeroMemory(ref MainDef.InDataA, 16);
			ZeroMem.ZeroMemory(ref MainDef.InDataB, 16);

			MainDef.OutKey++;
			MainDef.OutDataB[TeleToken.TVTTD_CMD] = TeleToken.TVTTC_CLOSE;      // rozkaz zakoczenia sesji

			TeleToken.TVTT_Calc(MainDef.OutDataA, ref MainDef.OutDataB);        // policzenie bloku kontrolnego
			TeleToken.TVTT_CryptBlock(ref MainDef.OutDataA, MainDef.OutKey,     // zaszyfrowanie pierwszego bloku danych
				MainDef.SessionKey, TeleToken.TVTT_BLOCK_A,
				TeleToken.TVTT_PC2T);
			TeleToken.TVTT_CryptBlock(ref MainDef.OutDataB, MainDef.OutKey,     // zaszyfrowanie drugiego bloku danych
				MainDef.SessionKey, TeleToken.TVTT_BLOCK_B,
				TeleToken.TVTT_PC2T);
			MainDef.Status = TeleToken.TVTT_Talk(MainDef.TokenH, 1,
				MainDef.OutKey, ref MainDef.OutDataA[0],
				ref MainDef.OutDataB[0], ref MainDef.InKey,
				ref MainDef.InDataA[0], ref MainDef.InDataB[0]);
			if (MainDef.Status != 0)
				Console.Write("\t\t{0:X}:{1:X02}\n", MainDef.Status>>8,
					MainDef.Status&0xFF);
			else
				Console.Write("\t\tOK\n");

			// zakoczenie sesji
			Console.Write("Zakonczenie sesji:");
			MainDef.Status = TeleToken.TVTT_EndSession(MainDef.TokenH);
			if (MainDef.Status != 0)
				Console.Write("\t\t{0:X}:{1:X02}\n", MainDef.Status>>8,
					MainDef.Status&0xFF);
			else
				Console.Write("\t\tOK\n");

			// zamknicie dostpu do Tokenu
			Console.Write("Zamkniecie dost. do TeleTokenu:");
			MainDef.Status = TeleToken.TVTT_FreeToken(MainDef.TokenH);
			if (MainDef.Status != 0)
				Console.Write("\t{0:X}:{1:X02}\n", MainDef.Status>>8,
					MainDef.Status&0xFF);
			else
				Console.Write("\tOK\n");

			MainDef.Time = MainDef.GetTickCount() - MainDef.Time;
			Console.Write("Time: {0:d}.{1:d02}\n", MainDef.Time/1000,
				(MainDef.Time/10)%100);
		}
	}
}
