using System;

using TeleVox_TeleToken;

namespace ExCommon
{
	public class Prolog
	{
		public Prolog()
		{
		}

		static public void Run()
		{
			// sprawdzenie wersji biblioteki
			Console.Write("Odczyt wersji biblioteki\n");
			MainDef.Status = TeleToken.TVTT_GetVersion(ref MainDef.Ver,
				ref MainDef.SubVer, ref MainDef.APIVer);
			Console.Write("\tWersja pliku:\t\t{0:d}.{1:d02}\n\tWersja API:\t\t{2:d}\n\n",
				MainDef.Ver, MainDef.SubVer, MainDef.APIVer);

			// otwarcie dostepu do TeleTokenu
			Console.Write("Otwarcie dostepu do TeleTokenu:");
			MainDef.TokenInfoTblSize = TeleToken.TVTTTI_TABLE_SIZE;             // wpisanie rozmiaru tablicy
			MainDef.Status = TeleToken.TVTT_FindToken(ref MainDef.TokenH, 10,
				TokenID.TOKEN_ID, TokenID.TOKEN_ID_MASK, 0,
				ref MainDef.TokenInfoTblSize, ref MainDef.TokenInfoTbl[0]);
			if (MainDef.Status != 0)
				Console.Write("\t{0:X}:{1:X02}\n", MainDef.Status>>8,
					MainDef.Status&0xFF);
			else
				Console.Write("\tOK\n");

			int n = 0;
			while (n<MainDef.TokenInfoTblSize) {
				Console.Write((GlobalDef.TokenInfoOffsetTbl[n] ==
					TeleToken.TVTTTI_ID)?"\t\t\t\t{0:s}{1:X08}\n":"\t\t\t\t{0:s}{1:d}\n",
					GlobalDef.TokenInfoTextTbl[n],
					MainDef.TokenInfoTbl[GlobalDef.TokenInfoOffsetTbl[n]]);
				n++;
			}

			// odczytanie nr. seryjnego TeleTokenu
                        Console.Write("Odczyt nr. ser. TeleTokenu:");
                        MainDef.Status = TeleToken.TVTT_GetSerialNr(MainDef.TokenH, 10, ref MainDef.SerialNr[0]);
                        if (MainDef.Status != 0)
				Console.Write("\t{0:X}:{1:X02}\n", MainDef.Status>>8,
					MainDef.Status&0xFF);
			else
				Console.Write("\tOK\n");
                        Console.Write("Numer seryjny:\t\t\t{0:X02}{1:X02}{2:X02}{3:X02}\n",
                        	MainDef.SerialNr[0], MainDef.SerialNr[1], MainDef.SerialNr[2], MainDef.SerialNr[3]);

			// rozpoczecie sesji
			Console.Write("Rozpoczecie sesji:");
			MainDef.Status = TeleToken.TVTT_StartSession(MainDef.TokenH, 1);
			if (MainDef.Status != 0)
				Console.Write("\t\t{0:X}:{1:X02}\n", MainDef.Status>>8,
					MainDef.Status&0xFF);
			else
				Console.Write("\t\tOK\n");

			// otwarcie sesji
			Console.Write("Otwarcie sesji:");

			ZeroMem.ZeroMemory(ref MainDef.OutDataA, 16);
			ZeroMem.ZeroMemory(ref MainDef.OutDataB, 16);
			ZeroMem.ZeroMemory(ref MainDef.InDataA, 16);
			ZeroMem.ZeroMemory(ref MainDef.InDataB, 16);

			MainDef.OutKey = 0;                                                 // znacznik wiadomoci nie szyfrowanej
			TeleToken.TVTT_Rand(ref MainDef.OutDataA);                          // wylosowanie tablicy losowej
			MainDef.OutDataB[TeleToken.TVTTD_CMD] = TeleToken.TVTTC_OPEN;       // rozkaz otwarcia sesji
			MainDef.OutDataB[TeleToken.TVTTD_PARAM1] = 0;                       // numer hasa proponowanego przez PC

			TeleToken.TVTT_Calc(MainDef.OutDataA, ref MainDef.OutDataB);        // policzenie bloku kontrolnego
			MainDef.Status = TeleToken.TVTT_Talk(MainDef.TokenH, 1,
				MainDef.OutKey, ref MainDef.OutDataA[0],
				ref MainDef.OutDataB[0],
				ref MainDef.InKey, ref MainDef.InDataA[0],
				ref MainDef.InDataB[0]);
			TeleToken.TVTT_CalcSessionKey(ref MainDef.SessionKey,               // policzenie klucza sesji
				GlobalDef.PassTbl[MainDef.OutDataB[TeleToken.TVTTD_PARAM1]],
				MainDef.OutDataA,
				GlobalDef.PassTbl[MainDef.InDataB[TeleToken.TVTTD_PARAM1]],
				MainDef.InDataA);
			if (MainDef.Status != 0)
				Console.Write("\t\t\t{0:X}:{1:X02}\n", MainDef.Status>>8,
					MainDef.Status&0xFF);
			else {
				if (TeleToken.TVTT_Check(MainDef.InDataA,
					ref MainDef.InDataB) != 0)
					Console.Write("\t\t\tBlad bloku kontrolnego!\n");
				else {
					if (MainDef.InDataB[TeleToken.TVTTD_STATUS] != 0)
						Console.Write("\t\t\t{0:X}\n",
							MainDef.InDataB[TeleToken.TVTTD_STATUS]);
					else
						Console.Write("\t\t\tOK\n");
				}
			}
		}
	}
}
