using System;

using TeleVox_TeleToken;
using ExCommon;

namespace ExFormat
{
	class Class
	{
		[STAThread]
		static void Main(string[] args)
		{
			byte[] FormatPass = new byte[5];
			FormatPass = TokenID.TOKEN_FORMAT_PASS;

			uint n;
			for (n = 0; n < GlobalDef.PASS_NO; n++)
				ZeroMem.ZeroMemory(ref GlobalDef.PassTbl[n], 16);

			// sprawdzenie wersji biblioteki
			Console.Write("Odczyt wersji biblioteki\n");
			MainDef.Status = TeleToken.TVTT_GetVersion(ref MainDef.Ver,
				ref MainDef.SubVer, ref MainDef.APIVer);
			Console.Write("\tWersja pliku:\t\t{0:d}.{1:d02}\n\tWersja API:\t\t{2:d}\n\n",
				MainDef.Ver, MainDef.SubVer, MainDef.APIVer);

			// otwarcie dostepu do TeleTokenu
			Console.Write("Otwarcie dostepu do TeleTokenu:");
			MainDef.TokenInfoTblSize = TeleToken.TVTTTI_TABLE_SIZE;             // wpisanie rozmiaru tablicy
			MainDef.Status = TeleToken.TVTT_FindToken(ref MainDef.TokenH, 10,
				TokenID.TOKEN_ID, 0, 0, ref MainDef.TokenInfoTblSize,
				ref MainDef.TokenInfoTbl[0]);
			if (MainDef.Status != 0)
				Console.Write("\t{0:X}:{1:X02}\n", MainDef.Status>>8,
					MainDef.Status&0xFF);
			else
				Console.Write("\tOK\n");

			n = 0;
			while (n<MainDef.TokenInfoTblSize) {
				Console.Write((GlobalDef.TokenInfoOffsetTbl[n] ==
					TeleToken.TVTTTI_ID)?
					"\t\t\t\t{0:s}{1:X08}\n":"\t\t\t\t{0:s}{1:d}\n",
					GlobalDef.TokenInfoTextTbl[n],
					MainDef.TokenInfoTbl[GlobalDef.TokenInfoOffsetTbl[n]]);
				n++;
			}

			// rozpoczecie sesji
			Console.Write("Rozpoczecie sesji:");
			MainDef.Status = TeleToken.TVTT_StartSession(MainDef.TokenH, 1);
			if (MainDef.Status != 0)
				Console.Write("\t{0:X}:{1:X02}\n", MainDef.Status>>8,
					MainDef.Status&0xFF);
			else
				Console.Write("\t\tOK\n");

			// format TeleTokenu
			Console.Write("Format TeleTokenu:");
			ZeroMem.ZeroMemory(ref MainDef.OutDataA, 16);
			ZeroMem.ZeroMemory(ref MainDef.OutDataB, 16);
			ZeroMem.ZeroMemory(ref MainDef.InDataA, 16);
			ZeroMem.ZeroMemory(ref MainDef.InDataB, 16);
			MainDef.OutKey = 0;                                                 // znacznik wiadomosci nie szyfrowanej
			MainDef.OutDataB[TeleToken.TVTTD_CMD] = TeleToken.TVTTC_FORMAT;     // rozkaz formatowania TeleTokenu
			MainDef.OutDataB[TeleToken.TVTTD_PARAM1] = 1;                       // najmodszy bajt ID odbiorcy TeleTokenu

			MainDef.OutDataA[0] = FormatPass[0];
			MainDef.OutDataA[1] = FormatPass[1];
			MainDef.OutDataA[2] = FormatPass[2];
			MainDef.OutDataA[3] = FormatPass[3];
			MainDef.OutDataA[4] = FormatPass[4];

                        // numer seryjny
			MainDef.OutDataA[5] = 0x01;
			MainDef.OutDataA[6] = 0x02;
			MainDef.OutDataA[7] = 0x03;
			MainDef.OutDataA[8] = 0x04;

			TeleToken.TVTT_Calc(MainDef.OutDataA, ref MainDef.OutDataB);        // policzenie bloku kontrolnego
			MainDef.Status = TeleToken.TVTT_Talk(MainDef.TokenH, 200,
				MainDef.OutKey, ref MainDef.OutDataA[0],
				ref MainDef.OutDataB[0], ref MainDef.InKey,
				ref MainDef.InDataA[0], ref MainDef.InDataB[0]);
			TeleToken.TVTT_CalcSessionKey(ref MainDef.SessionKey,               // policzenie klucza sesji
				GlobalDef.PassTbl[MainDef.OutDataB[TeleToken.TVTTD_PARAM1]],
				MainDef.OutDataA,
				GlobalDef.PassTbl[MainDef.InDataB[TeleToken.TVTTD_PARAM1]],
				MainDef.InDataA);
			if (MainDef.Status == 0x0600)
				Console.Write("\t\tRestart TeleTokenu...\n");
			else
				Console.Write("\t\t{0:X}:{1:X02}\n", MainDef.Status>>8,
					MainDef.Status&0xFF);

			// zakonczenie sesji
			Console.Write("Zakonczenie sesji:");
			MainDef.Status = TeleToken.TVTT_EndSession(MainDef.TokenH);
			if (MainDef.Status != 0)
				Console.Write("\t\t{0:X}:{1:X02}\n", MainDef.Status>>8,
					MainDef.Status&0xFF);
			else
				Console.Write("\t\tOK\n");

			// zamknicie dostpu do TeleTokenu
			Console.Write("Zamkniecie dost. do TeleTokenu:");
			MainDef.Status = TeleToken.TVTT_FreeToken(MainDef.TokenH);
			if (MainDef.Status != 0)
				Console.Write("\t{0:X}:{1:X02}\n", MainDef.Status>>8,
					MainDef.Status&0xFF);
			else
				Console.Write("\tOK\n");

			MainDef.Time = MainDef.GetTickCount() - MainDef.Time;
			Console.Write("Time: {0:d}.{1:d02}\n", MainDef.Time/1000,
				(MainDef.Time/10)%100);

			return;
		}
	}
}
