using System;

using TeleVox_TeleToken;
using ExCommon;

namespace ExNvMemDecryptWrite
{
	class Class
	{
		[STAThread]
		static void Main(string[] args)
		{
			uint n, m, c;
			for (n = 0; n < GlobalDef.PASS_NO; n++)
				ZeroMem.ZeroMemory(ref GlobalDef.PassTbl[n], 16);

			string stmp;
			n = 0;
			while (n<GlobalDef.PASS_NO) {
				stmp = "Pass" + n;
				ZeroMem.StrCopy(ref GlobalDef.PassTbl[n], stmp);
				n++;
			}

                        byte[] iv = new byte[16];
                        TeleToken.TVTT_Rand(ref iv);

			Prolog.Run();

                        /* Przykad obrazujcy zapis zaszyfrowanych danych do TeleTokenu. Zademonstrowane jest
                           uycie trybu CBC do zaszyfrowania (przygotowania) danych do zapisu do TeleTokenu.
                           Z drugiej strony TeleToken podczas operacji zapisu rozszyfrowywuje dane rwnie
                           w trybie CBC, z uyciem wbudowanej pamici ulotnej (1 sektora). */

			// zainicjowanie OutKey
			MainDef.OutKey = (MainDef.GetTickCount() & 0xFFFFFF00) | 0xF00;

                        byte[][] data = new byte[MainDef.TokenInfoTbl[TeleToken.TVTTTI_NV_MEM_SIZE]][];

                        // przygotowanie danych do zapisania
                        for (n=0; n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_NV_MEM_SIZE]; n++) {
                        	data[n] = new byte[16];
                                for (m=0; m<16; m++) data[n][m] = (byte) (n*16+m);
                        }

                        /* szyfrowanie metoda CBC */

                        // XOR 1 bloku danych z init vector-em
                        for (n=0; n<16; n++) data[0][n] ^= iv[n];

                        // petla szyfrujca
                        n = MainDef.TokenInfoTbl[TeleToken.TVTTTI_NV_MEM_SIZE];
                        m = 0;
                        while (true) {
                                rijndael.rijndaelEncrypt(GlobalDef.PassTbl[0], ref data[m]);

                                if (--n == 0) break;

                                m++;

                                // XOR bloku n z zaszyfrowanym blokiem n-1
                                for (c=0; c<16; c++) data[m][c] ^= data[m-1][c];
                        }

                        /* Przygotowanie sektora pamici ulotnej do deszyfrowania w trybie CBC. Do sektora "0"
                           wgrywany jest "init vector", z ktrym TeleToken automatycznie wykona operacj XOR
                           po uprzednim zdeszyfrowaniu pierwszego bloku danych. Po tej operacji pierwszy
                           zaszyfrowany blok danych trafi do wybranego (tu "0") sektora RAM, na poczet przyszego
                           wykorzystania do operacji XOR. Tym sposobem do wykonania zapisu z deszyfrowaniem
                           w trybie CBC naley tylko raz, przed rozpoczciem deszyfrowania, wgra blok pocztkowy
                           ("init vector") do wybranego sektora pamici RAM. Numer tego sektora podawany jest
                           jako argument w rozkazie "deszyfruj i zapisz". Podanie numeru spoza zakresu (0-7)
                           spowoduje uycie deszyfrowania w trybie ECB (kady blok osobno). */

                        // zapis IV do pamici ulotnej

			Console.Write("Zapis pam. ul. TeleTokenu:");

                        ZeroMem.ZeroMemory(ref MainDef.OutDataA, 16);
                        ZeroMem.ZeroMemory(ref MainDef.OutDataB, 16);
                        ZeroMem.ZeroMemory(ref MainDef.InDataA, 16);
                        ZeroMem.ZeroMemory(ref MainDef.InDataB, 16);

                        MainDef.OutKey++;                                               // zwikszenie licznika kluczy

                        MainDef.OutDataB[TeleToken.TVTTD_CMD] =
                                TeleToken.TVTTC_VMEM_WRITE;                             // rozkaz zapisu pamici ul. TeleTokenu
                        MainDef.OutDataB[TeleToken.TVTTD_PARAM1]= 0;                    // numer sektora do zapisania

                        for (n=0; n<16; n++) MainDef.OutDataA[n] = iv[n];

                        TeleToken.TVTT_Calc(MainDef.OutDataA, ref MainDef.OutDataB);    // policzenie bloku kontrolnego
                        TeleToken.TVTT_CryptBlock(ref MainDef.OutDataA, MainDef.OutKey, // zaszyfrowanie pierwszego bloku danych
                                MainDef.SessionKey, TeleToken.TVTT_BLOCK_A,
                                TeleToken.TVTT_PC2T);
                        TeleToken.TVTT_CryptBlock(ref MainDef.OutDataB, MainDef.OutKey, // zaszyfrowanie drugiego bloku danych
                                MainDef.SessionKey, TeleToken.TVTT_BLOCK_B,
                                TeleToken.TVTT_PC2T);
                        MainDef.Status = TeleToken.TVTT_Talk(MainDef.TokenH, 2,
                                MainDef.OutKey, ref MainDef.OutDataA[0],
                                ref MainDef.OutDataB[0], ref MainDef.InKey,
                                ref MainDef.InDataA[0], ref MainDef.InDataB[0]);
                        TeleToken.TVTT_CryptBlock(ref MainDef.InDataA, MainDef.InKey,   // rozszyfrowanie pierwszego bloku danych
                                MainDef.SessionKey, TeleToken.TVTT_BLOCK_A,
                                TeleToken.TVTT_T2PC);
                        TeleToken.TVTT_CryptBlock(ref MainDef.InDataB, MainDef.InKey,   // rozszyfrowanie drugiego bloku danych
                                MainDef.SessionKey, TeleToken.TVTT_BLOCK_B,
                                TeleToken.TVTT_T2PC);

                        if (MainDef.Status != 0) {
                                Console.Write("\t{0:X}:{1:X02}\n", MainDef.Status>>8,
                                        MainDef.Status&0xFF);
                                goto fail;
                        }

                        if (TeleToken.TVTT_Check(MainDef.InDataA,
                                ref MainDef.InDataB) != 0) {
                                Console.Write("\tBlad bloku kontrolnego!\n");
                                goto fail;
                        }

                        if (MainDef.InDataB[TeleToken.TVTTD_STATUS] != 0) {
                                Console.Write("\t{0:X}\n",
                                        MainDef.InDataB[TeleToken.TVTTD_STATUS]);
                                goto fail;
                        }

                        if (MainDef.InKey == 0) {                                       // sprawdzenie czy wiadomo zaszyfrowana
                                Console.Write("\tWiadomosc nie zaszyfrowana!\n");
                                goto fail;
                        }

			Console.Write("\tOK\n");

                        // zapis pamici nieulotnej TeleTokenu

			Console.Write("Zapis pam. nieul. TeleTokenu:");

			n = 0;
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_NV_MEM_SIZE])
				{
				ZeroMem.ZeroMemory(ref MainDef.OutDataA, 16);
				ZeroMem.ZeroMemory(ref MainDef.OutDataB, 16);
				ZeroMem.ZeroMemory(ref MainDef.InDataA, 16);
				ZeroMem.ZeroMemory(ref MainDef.InDataB, 16);

				MainDef.OutKey++;                                               // zwikszenie licznika kluczy

				MainDef.OutDataB[TeleToken.TVTTD_CMD] =
					TeleToken.TVTTC_NVMEM_DECRYPT_WRITE;                    // rozkaz zapisu z deszyfrowaniem pamici TeleTokenu
				MainDef.OutDataB[TeleToken.TVTTD_PARAM1]= (byte) n;             // numer sektora do zapisania
				MainDef.OutDataB[TeleToken.TVTTD_PARAM2]= 0;                    // numer klucza do uycia przy deszyfrowaniu
				MainDef.OutDataB[TeleToken.TVTTD_PARAM3]= 0;                    // numer sektora pamici ulotnej do uycia przy deszyfrowaniu trybem CBC

				for (m=0; m<16; m++)
                                	MainDef.OutDataA[m] = data[n][m];                       // wypenienie bufora danymi do zapisania

				TeleToken.TVTT_Calc(MainDef.OutDataA, ref MainDef.OutDataB);    // policzenie bloku kontrolnego
				TeleToken.TVTT_CryptBlock(ref MainDef.OutDataA, MainDef.OutKey, // zaszyfrowanie pierwszego bloku danych
					MainDef.SessionKey, TeleToken.TVTT_BLOCK_A,
					TeleToken.TVTT_PC2T);
				TeleToken.TVTT_CryptBlock(ref MainDef.OutDataB, MainDef.OutKey, // zaszyfrowanie drugiego bloku danych
					MainDef.SessionKey, TeleToken.TVTT_BLOCK_B,
					TeleToken.TVTT_PC2T);
				MainDef.Status = TeleToken.TVTT_Talk(MainDef.TokenH, 2,
					MainDef.OutKey, ref MainDef.OutDataA[0],
					ref MainDef.OutDataB[0], ref MainDef.InKey,
					ref MainDef.InDataA[0], ref MainDef.InDataB[0]);
				TeleToken.TVTT_CryptBlock(ref MainDef.InDataA, MainDef.InKey,   // rozszyfrowanie pierwszego bloku danych
					MainDef.SessionKey, TeleToken.TVTT_BLOCK_A,
					TeleToken.TVTT_T2PC);
				TeleToken.TVTT_CryptBlock(ref MainDef.InDataB, MainDef.InKey,   // rozszyfrowanie drugiego bloku danych
					MainDef.SessionKey, TeleToken.TVTT_BLOCK_B,
					TeleToken.TVTT_T2PC);

				if (MainDef.Status != 0) {
					Console.Write("\t{0:X}:{1:X02}\n", MainDef.Status>>8,
						MainDef.Status&0xFF);
					break;
				}

				if (TeleToken.TVTT_Check(MainDef.InDataA,
					ref MainDef.InDataB) != 0) {
					Console.Write("\tBlad bloku kontrolnego!\n");
					break;
				}

				if (MainDef.InDataB[TeleToken.TVTTD_STATUS] != 0) {
					Console.Write("\t{0:X}\n",
						MainDef.InDataB[TeleToken.TVTTD_STATUS]);
					break;
				}

				if (MainDef.InKey == 0) {                                       // sprawdzenie czy wiadomo zaszyfrowana
					Console.Write("\tWiadomosc nie zaszyfrowana!\n");
					break;
				}

				n++;
			}
			if (n == MainDef.TokenInfoTbl[TeleToken.TVTTTI_NV_MEM_SIZE])
				Console.Write("\tOK\n");

fail:
			Epilog.Run();

			return;
		}
	}
}
