using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

using TeleVox_TeleToken;
using ExCommon;

namespace ExApi
{
	public class frmRoot : System.Windows.Forms.Form
	{
		private const string CRLF = "\r\n";
		private const string cOK = "OK\r\n--------------------";

		private CTVTTAPI_INT_CON GCon = null;
		private byte NumPassT;
		private byte[] Pass = new byte[16];
		private uint Status;
		private byte OwnerMsk = 0xFF;
		private byte[] CryptBuff = new byte[16];

		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox Memo;
		private System.Windows.Forms.Button btnOpen;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Button btnGetFeature;
		private System.Windows.Forms.Button btnRamWrite;
		private System.Windows.Forms.Button btnRamRead;
		private System.Windows.Forms.Button btnMemWrite;
		private System.Windows.Forms.Button btnMemRead;
		private System.Windows.Forms.Button btnMemWriteProtect;
		private System.Windows.Forms.Button btnMemProtect;
		private System.Windows.Forms.Button btnCntWrite;
		private System.Windows.Forms.Button btnCntRead;
		private System.Windows.Forms.Button btnCntIncRead;
		private System.Windows.Forms.Button btnCntDecRead;
		private System.Windows.Forms.Button btnCntIncEncRead;
		private System.Windows.Forms.Button btnCntConfigWrite;
		private System.Windows.Forms.Button btnCntConfigSet;
		private System.Windows.Forms.Button btnCntConfigClear;
		private System.Windows.Forms.Button btnPassWrite;
		private System.Windows.Forms.Button btnPassConfigWrite;
		private System.Windows.Forms.Button btnPassConfigSet;
		private System.Windows.Forms.Button btnPassConfigClear;
		private System.Windows.Forms.Button btnEncrypt;
		private System.Windows.Forms.Button btnDecrypt;
		private System.Windows.Forms.Button btnEncryptBlock;
		private System.Windows.Forms.Button btnDecryptBlock;
		private System.Windows.Forms.Button btnRand;
		private System.Windows.Forms.OpenFileDialog OpenDlg;

		public frmRoot()
		{
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		protected override void Dispose(bool disposing)
		{
			if (disposing) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Memo = new System.Windows.Forms.TextBox();
			this.btnOpen = new System.Windows.Forms.Button();
			this.btnClose = new System.Windows.Forms.Button();
			this.btnGetFeature = new System.Windows.Forms.Button();
			this.btnRamWrite = new System.Windows.Forms.Button();
			this.btnRamRead = new System.Windows.Forms.Button();
			this.btnMemWrite = new System.Windows.Forms.Button();
			this.btnMemRead = new System.Windows.Forms.Button();
			this.btnMemWriteProtect = new System.Windows.Forms.Button();
			this.btnMemProtect = new System.Windows.Forms.Button();
			this.btnCntWrite = new System.Windows.Forms.Button();
			this.btnCntRead = new System.Windows.Forms.Button();
			this.btnCntIncRead = new System.Windows.Forms.Button();
			this.btnCntDecRead = new System.Windows.Forms.Button();
			this.btnCntIncEncRead = new System.Windows.Forms.Button();
			this.btnCntConfigWrite = new System.Windows.Forms.Button();
			this.btnCntConfigSet = new System.Windows.Forms.Button();
			this.btnCntConfigClear = new System.Windows.Forms.Button();
			this.btnPassWrite = new System.Windows.Forms.Button();
			this.btnPassConfigWrite = new System.Windows.Forms.Button();
			this.btnPassConfigSet = new System.Windows.Forms.Button();
			this.btnPassConfigClear = new System.Windows.Forms.Button();
			this.btnEncrypt = new System.Windows.Forms.Button();
			this.btnDecrypt = new System.Windows.Forms.Button();
			this.btnEncryptBlock = new System.Windows.Forms.Button();
			this.btnDecryptBlock = new System.Windows.Forms.Button();
			this.btnRand = new System.Windows.Forms.Button();
			this.OpenDlg = new System.Windows.Forms.OpenFileDialog();
			this.SuspendLayout();
			// 
			// Memo
			// 
			this.Memo.BackColor = System.Drawing.SystemColors.Window;
			this.Memo.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(238)));
			this.Memo.Location = new System.Drawing.Point(0, 0);
			this.Memo.Multiline = true;
			this.Memo.Name = "Memo";
			this.Memo.ReadOnly = true;
			this.Memo.Size = new System.Drawing.Size(400, 688);
			this.Memo.TabIndex = 0;
			this.Memo.Text = "";
			// 
			// btnOpen
			// 
			this.btnOpen.Location = new System.Drawing.Point(408, 8);
			this.btnOpen.Name = "btnOpen";
			this.btnOpen.Size = new System.Drawing.Size(104, 23);
			this.btnOpen.TabIndex = 1;
			this.btnOpen.Text = "Open";
			this.btnOpen.Click += new System.EventHandler(this.btnOpen_Click);
			// 
			// btnClose
			// 
			this.btnClose.Location = new System.Drawing.Point(408, 32);
			this.btnClose.Name = "btnClose";
			this.btnClose.Size = new System.Drawing.Size(104, 23);
			this.btnClose.TabIndex = 2;
			this.btnClose.Text = "Close";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// btnGetFeature
			// 
			this.btnGetFeature.Location = new System.Drawing.Point(408, 56);
			this.btnGetFeature.Name = "btnGetFeature";
			this.btnGetFeature.Size = new System.Drawing.Size(104, 23);
			this.btnGetFeature.TabIndex = 3;
			this.btnGetFeature.Text = "GetFeature";
			this.btnGetFeature.Click += new System.EventHandler(this.btnGetFeature_Click);
			// 
			// btnRamWrite
			// 
			this.btnRamWrite.Location = new System.Drawing.Point(408, 88);
			this.btnRamWrite.Name = "btnRamWrite";
			this.btnRamWrite.Size = new System.Drawing.Size(104, 23);
			this.btnRamWrite.TabIndex = 4;
			this.btnRamWrite.Text = "RamWrite";
			this.btnRamWrite.Click += new System.EventHandler(this.btnRamWrite_Click);
			// 
			// btnRamRead
			// 
			this.btnRamRead.Location = new System.Drawing.Point(408, 112);
			this.btnRamRead.Name = "btnRamRead";
			this.btnRamRead.Size = new System.Drawing.Size(104, 23);
			this.btnRamRead.TabIndex = 5;
			this.btnRamRead.Text = "RamRead";
			this.btnRamRead.Click += new System.EventHandler(this.btnRamRead_Click);
			// 
			// btnMemWrite
			// 
			this.btnMemWrite.Location = new System.Drawing.Point(408, 144);
			this.btnMemWrite.Name = "btnMemWrite";
			this.btnMemWrite.Size = new System.Drawing.Size(104, 23);
			this.btnMemWrite.TabIndex = 6;
			this.btnMemWrite.Text = "MemWrite";
			this.btnMemWrite.Click += new System.EventHandler(this.btnMemWrite_Click);
			// 
			// btnMemRead
			// 
			this.btnMemRead.Location = new System.Drawing.Point(408, 168);
			this.btnMemRead.Name = "btnMemRead";
			this.btnMemRead.Size = new System.Drawing.Size(104, 23);
			this.btnMemRead.TabIndex = 7;
			this.btnMemRead.Text = "MemRead";
			this.btnMemRead.Click += new System.EventHandler(this.btnMemRead_Click);
			// 
			// btnMemWriteProtect
			// 
			this.btnMemWriteProtect.Location = new System.Drawing.Point(408, 192);
			this.btnMemWriteProtect.Name = "btnMemWriteProtect";
			this.btnMemWriteProtect.Size = new System.Drawing.Size(104, 23);
			this.btnMemWriteProtect.TabIndex = 8;
			this.btnMemWriteProtect.Text = "MemWriteProtect";
			this.btnMemWriteProtect.Click += new System.EventHandler(this.btnMemWriteProtect_Click);
			// 
			// btnMemProtect
			// 
			this.btnMemProtect.Location = new System.Drawing.Point(408, 216);
			this.btnMemProtect.Name = "btnMemProtect";
			this.btnMemProtect.Size = new System.Drawing.Size(104, 23);
			this.btnMemProtect.TabIndex = 9;
			this.btnMemProtect.Text = "MemProtect";
			this.btnMemProtect.Click += new System.EventHandler(this.btnMemProtect_Click);
			// 
			// btnCntWrite
			// 
			this.btnCntWrite.Location = new System.Drawing.Point(408, 248);
			this.btnCntWrite.Name = "btnCntWrite";
			this.btnCntWrite.Size = new System.Drawing.Size(104, 23);
			this.btnCntWrite.TabIndex = 10;
			this.btnCntWrite.Text = "CntWrite";
			this.btnCntWrite.Click += new System.EventHandler(this.btnCntWrite_Click);
			// 
			// btnCntRead
			// 
			this.btnCntRead.Location = new System.Drawing.Point(408, 272);
			this.btnCntRead.Name = "btnCntRead";
			this.btnCntRead.Size = new System.Drawing.Size(104, 23);
			this.btnCntRead.TabIndex = 11;
			this.btnCntRead.Text = "CntRead";
			this.btnCntRead.Click += new System.EventHandler(this.btnCntRead_Click);
			// 
			// btnCntIncRead
			// 
			this.btnCntIncRead.Location = new System.Drawing.Point(408, 296);
			this.btnCntIncRead.Name = "btnCntIncRead";
			this.btnCntIncRead.Size = new System.Drawing.Size(104, 23);
			this.btnCntIncRead.TabIndex = 12;
			this.btnCntIncRead.Text = "CntIncRead";
			this.btnCntIncRead.Click += new System.EventHandler(this.btnCntIncRead_Click);
			// 
			// btnCntDecRead
			// 
			this.btnCntDecRead.Location = new System.Drawing.Point(408, 320);
			this.btnCntDecRead.Name = "btnCntDecRead";
			this.btnCntDecRead.Size = new System.Drawing.Size(104, 23);
			this.btnCntDecRead.TabIndex = 13;
			this.btnCntDecRead.Text = "CntDecRead";
			this.btnCntDecRead.Click += new System.EventHandler(this.btnCntDecRead_Click);
			// 
			// btnCntIncEncRead
			// 
			this.btnCntIncEncRead.Location = new System.Drawing.Point(408, 344);
			this.btnCntIncEncRead.Name = "btnCntIncEncRead";
			this.btnCntIncEncRead.Size = new System.Drawing.Size(104, 23);
			this.btnCntIncEncRead.TabIndex = 14;
			this.btnCntIncEncRead.Text = "CntIncEncRead";
			this.btnCntIncEncRead.Click += new System.EventHandler(this.btnCntIncEncRead_Click);
			// 
			// btnCntConfigWrite
			// 
			this.btnCntConfigWrite.Location = new System.Drawing.Point(408, 368);
			this.btnCntConfigWrite.Name = "btnCntConfigWrite";
			this.btnCntConfigWrite.Size = new System.Drawing.Size(104, 23);
			this.btnCntConfigWrite.TabIndex = 15;
			this.btnCntConfigWrite.Text = "CntConfigWrite";
			this.btnCntConfigWrite.Click += new System.EventHandler(this.btnCntConfigWrite_Click);
			// 
			// btnCntConfigSet
			// 
			this.btnCntConfigSet.Location = new System.Drawing.Point(408, 392);
			this.btnCntConfigSet.Name = "btnCntConfigSet";
			this.btnCntConfigSet.Size = new System.Drawing.Size(104, 23);
			this.btnCntConfigSet.TabIndex = 16;
			this.btnCntConfigSet.Text = "CntConfigSet";
			this.btnCntConfigSet.Click += new System.EventHandler(this.btnCntConfigSet_Click);
			// 
			// btnCntConfigClear
			// 
			this.btnCntConfigClear.Location = new System.Drawing.Point(408, 416);
			this.btnCntConfigClear.Name = "btnCntConfigClear";
			this.btnCntConfigClear.Size = new System.Drawing.Size(104, 23);
			this.btnCntConfigClear.TabIndex = 17;
			this.btnCntConfigClear.Text = "CntConfigClear";
			this.btnCntConfigClear.Click += new System.EventHandler(this.btnCntConfigClear_Click);
			// 
			// btnPassWrite
			// 
			this.btnPassWrite.Location = new System.Drawing.Point(408, 448);
			this.btnPassWrite.Name = "btnPassWrite";
			this.btnPassWrite.Size = new System.Drawing.Size(104, 23);
			this.btnPassWrite.TabIndex = 18;
			this.btnPassWrite.Text = "PassWrite";
			this.btnPassWrite.Click += new System.EventHandler(this.btnPassWrite_Click);
			// 
			// btnPassConfigWrite
			// 
			this.btnPassConfigWrite.Location = new System.Drawing.Point(408, 472);
			this.btnPassConfigWrite.Name = "btnPassConfigWrite";
			this.btnPassConfigWrite.Size = new System.Drawing.Size(104, 23);
			this.btnPassConfigWrite.TabIndex = 19;
			this.btnPassConfigWrite.Text = "PassConfigWrite";
			this.btnPassConfigWrite.Click += new System.EventHandler(this.btnPassConfigWrite_Click);
			// 
			// btnPassConfigSet
			// 
			this.btnPassConfigSet.Location = new System.Drawing.Point(408, 496);
			this.btnPassConfigSet.Name = "btnPassConfigSet";
			this.btnPassConfigSet.Size = new System.Drawing.Size(104, 23);
			this.btnPassConfigSet.TabIndex = 20;
			this.btnPassConfigSet.Text = "PassConfigSet";
			this.btnPassConfigSet.Click += new System.EventHandler(this.btnPassConfigSet_Click);
			// 
			// btnPassConfigClear
			// 
			this.btnPassConfigClear.Location = new System.Drawing.Point(408, 520);
			this.btnPassConfigClear.Name = "btnPassConfigClear";
			this.btnPassConfigClear.Size = new System.Drawing.Size(104, 23);
			this.btnPassConfigClear.TabIndex = 21;
			this.btnPassConfigClear.Text = "PassConfigClear";
			this.btnPassConfigClear.Click += new System.EventHandler(this.btnPassConfigClear_Click);
			// 
			// btnEncrypt
			// 
			this.btnEncrypt.Location = new System.Drawing.Point(408, 552);
			this.btnEncrypt.Name = "btnEncrypt";
			this.btnEncrypt.Size = new System.Drawing.Size(104, 23);
			this.btnEncrypt.TabIndex = 22;
			this.btnEncrypt.Text = "Encrypt";
			this.btnEncrypt.Click += new System.EventHandler(this.btnEncrypt_Click);
			// 
			// btnDecrypt
			// 
			this.btnDecrypt.Location = new System.Drawing.Point(408, 576);
			this.btnDecrypt.Name = "btnDecrypt";
			this.btnDecrypt.Size = new System.Drawing.Size(104, 23);
			this.btnDecrypt.TabIndex = 23;
			this.btnDecrypt.Text = "Decrypt";
			this.btnDecrypt.Click += new System.EventHandler(this.btnDecrypt_Click);
			// 
			// btnEncryptBlock
			// 
			this.btnEncryptBlock.Location = new System.Drawing.Point(408, 600);
			this.btnEncryptBlock.Name = "btnEncryptBlock";
			this.btnEncryptBlock.Size = new System.Drawing.Size(104, 23);
			this.btnEncryptBlock.TabIndex = 24;
			this.btnEncryptBlock.Text = "EncryptBlock";
			this.btnEncryptBlock.Click += new System.EventHandler(this.btnEncryptBlock_Click);
			// 
			// btnDecryptBlock
			// 
			this.btnDecryptBlock.Location = new System.Drawing.Point(408, 624);
			this.btnDecryptBlock.Name = "btnDecryptBlock";
			this.btnDecryptBlock.Size = new System.Drawing.Size(104, 23);
			this.btnDecryptBlock.TabIndex = 25;
			this.btnDecryptBlock.Text = "DecryptBlock";
			this.btnDecryptBlock.Click += new System.EventHandler(this.btnDecryptBlock_Click);
			// 
			// btnRand
			// 
			this.btnRand.Location = new System.Drawing.Point(408, 656);
			this.btnRand.Name = "btnRand";
			this.btnRand.Size = new System.Drawing.Size(104, 23);
			this.btnRand.TabIndex = 26;
			this.btnRand.Text = "Rand";
			this.btnRand.Click += new System.EventHandler(this.btnRand_Click);
			// 
			// frmRoot
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(520, 685);
			this.Controls.Add(this.btnRand);
			this.Controls.Add(this.btnDecryptBlock);
			this.Controls.Add(this.btnEncryptBlock);
			this.Controls.Add(this.btnDecrypt);
			this.Controls.Add(this.btnEncrypt);
			this.Controls.Add(this.btnPassConfigClear);
			this.Controls.Add(this.btnPassConfigSet);
			this.Controls.Add(this.btnPassConfigWrite);
			this.Controls.Add(this.btnPassWrite);
			this.Controls.Add(this.btnCntConfigClear);
			this.Controls.Add(this.btnCntConfigSet);
			this.Controls.Add(this.btnCntConfigWrite);
			this.Controls.Add(this.btnCntIncEncRead);
			this.Controls.Add(this.btnCntDecRead);
			this.Controls.Add(this.btnCntIncRead);
			this.Controls.Add(this.btnCntRead);
			this.Controls.Add(this.btnCntWrite);
			this.Controls.Add(this.btnMemProtect);
			this.Controls.Add(this.btnMemWriteProtect);
			this.Controls.Add(this.btnMemRead);
			this.Controls.Add(this.btnMemWrite);
			this.Controls.Add(this.btnRamRead);
			this.Controls.Add(this.btnRamWrite);
			this.Controls.Add(this.btnGetFeature);
			this.Controls.Add(this.btnClose);
			this.Controls.Add(this.btnOpen);
			this.Controls.Add(this.Memo);
			this.MaximizeBox = false;
			this.Name = "frmRoot";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "ExApi";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmRoot_Closing);
			this.Load += new System.EventHandler(this.frmRoot_Load);
			this.ResumeLayout(false);
		}
		#endregion

		[STAThread]
		static void Main()
		{
			Application.Run(new frmRoot());
		}

		private void frmRoot_Load(object sender, System.EventArgs e)
		{
			//wywoanie funkcji inicjalizujc bibliotek TeleTokenApi
			TeleTokenAPI.TVTTAPI_Initialize();

			//utworzenie tablicy hase dla TeleTokenu
			byte n = 0;
			string stmp;
			while (n<GlobalDef.PASS_NO) {
				stmp = "Pass" + n;
				ZeroMem.StrCopy(ref GlobalDef.PassTbl[n], stmp);
				n++;
			}
		}
		
		private void frmRoot_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (GCon != null) btnClose_Click(null, null);
		}

		private int OpenSession()
		{
			string sErr = "StartSession error" + CRLF + "--------------------";

			// sprawdzenie czy uchwyt na TeleToken nie jest wyzerowany
			if (GCon == null) {
				Memo.AppendText(sErr+CRLF);
				return -1;
			}

			// prba otwarcia sesji
			NumPassT = TeleTokenAPI.TVTTAPI_StartSession(Pass, GCon, 1);

			// obsuga bdw
			Status = TeleToken.GetLastError();
			if (GlobErr.CheckErr(Status) != 0) {
				Memo.AppendText(sErr+CRLF);
				return -1;
			}

			// obliczenie hase dla rozkazu sesji
			byte[] TmpTbl1 = new byte[16];
			byte[] TmpTbl2 = new byte[16];
			for (int i=0; i<16; i++) {
				TmpTbl1[i] = GlobalDef.PassTbl[1][i];
				TmpTbl2[i] = GlobalDef.PassTbl[NumPassT][i];
			}
			TeleTokenAPI.TVTTAPI_CalcPass(Pass, GCon, TmpTbl1, TmpTbl2);

			// obsuga bdw
			Status = TeleToken.GetLastError();
			if (GlobErr.CheckErr(Status) != 0) return -1;

			return 0;
		}

		private int CloseSession()
		{
			// zamknicie sesji
			TeleTokenAPI.TVTTAPI_EndSession(Pass, GCon);

			// obsuga bdw
			Status = TeleToken.GetLastError();
			if (GlobErr.CheckErr(Status) != 0) {
				Memo.AppendText("EndSession error" + CRLF +
					"--------------------" + CRLF);
				return -1;
			}

			return 0;
		}
		
		private void btnOpen_Click(object sender, System.EventArgs e)
		{
			// sprawdzenie czy otwarto wczeniej TeleToken
			if (GCon != null) {
				Memo.AppendText("TeleToken jest ju otwarty" + CRLF +
					"--------------------" + CRLF);
				return;
			}

			// losowanie hase dla sesji
			TeleTokenAPI.TVTTAPI_Rand(ref Pass);

			Memo.AppendText("Open" + CRLF);

			// otwarcie pierwszego TeleTokenu o ID zapisanym w TOKEN_ID
			GCon = TeleTokenAPI.TVTTAPI_Open(Pass, TokenID.TOKEN_ID,
				OwnerMsk, 0);

			// obsuga bdw
			Status = TeleToken.GetLastError();
			if (GlobErr.CheckErr(Status) != 0) {
				Memo.AppendText("Open error" + CRLF + "--------------------" +
					CRLF);
				return;
			}
			Memo.AppendText(cOK+CRLF);

			// wywoanie GetFeature w celu odczytania parametrw, TeleTokenu
			btnGetFeature_Click(null, null);
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			// zamknicie TeleTokenu
			TeleTokenAPI.TVTTAPI_Close(Pass, GCon);

			// obsuga bdw
			Status = TeleToken.GetLastError();
			if (GlobErr.CheckErr(Status) != 0) {
				Memo.AppendText("Close error" + CRLF + "--------------------" +
					CRLF);
				return;
			}

			// zwolnienie uchwytu na TeleToken
			GCon = null;

			Memo.AppendText("Close OK" + CRLF + "--------------------" + CRLF);
		}

		private void btnGetFeature_Click(object sender, System.EventArgs e)
		{
			Memo.AppendText(CRLF + "GetFeature" + CRLF);

			uint cFeature;
			string sTmp = "";
			// ptla odczytujca parametry TeleTokenu
			//---------------------------------------
			for (byte n=0; n<TeleToken.TVTTTI_TABLE_SIZE; n++) {
				// odczyt kolejnego parametru
				cFeature = TeleTokenAPI.TVTTAPI_GetFeature(Pass, GCon, n);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("GetFeature error" + CRLF +
						"--------------------" + CRLF);
					return;
				}

				// zapamitanie parametru TeleTokenu w tablicy
				MainDef.TokenInfoTbl[n] = cFeature;

				// dodanie parametru do linii tekstu
				sTmp += GlobalDef.TokenInfoTextTbl[n] + cFeature + CRLF;
			}
			//---------------------------------------

			// wywietlenie odczytanych danych o TeleTokenie
			Memo.AppendText(sTmp+CRLF);
			Memo.AppendText(cOK+CRLF);
		}

		private void btnRamWrite_Click(object sender, System.EventArgs e)
		{
			byte[] Buff = new byte[16]; // bufor na dane do zapisu
			string sText; // linia tekstu
			byte n; // zmienna pomocnicza

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// wypenienie bufora do zapisu przykadowymi wartociami
			TeleTokenAPI.TVTTAPI_Rand(ref Buff);

			// zapis bufora do pamici RAM
			TeleTokenAPI.TVTTAPI_RamWrite(Pass, GCon, 0, Buff);

			// obsuga bdw
			Status = TeleToken.GetLastError();
			if (GlobErr.CheckErr(Status) != 0) {
				Memo.AppendText("RamWrite error" + CRLF +
					"--------------------" + CRLF);
				CloseSession();
				return;
			}

			// wywietlenie danych zapisanych do pamici
			Memo.AppendText(CRLF + "RamWrite" + CRLF);
			n = 0;
			sText = "";
			while (n<16) {
				sText += " " + string.Format("{0:X02}", Buff[n]);
				n++;
			}

			Memo.AppendText(sText+CRLF);
			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnRamRead_Click(object sender, System.EventArgs e)
		{
			byte[] Buff = new byte[16]; // bufor na odczytane dane
			string sText; // linia tekstu
			byte n; // zmienna pomocnicza

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// odczyt pamici RAM
			TeleTokenAPI.TVTTAPI_RamRead(Pass, GCon, 0, ref Buff);

			// obsuga bdw
			Status = TeleToken.GetLastError();
			if (GlobErr.CheckErr(Status) != 0) {
				Memo.AppendText("RamRead error" + CRLF +
					"--------------------" + CRLF);
				CloseSession(); // zamknicie sesji
				return;
			}

			// wywietlenie odczytanych danych
			Memo.AppendText(CRLF + "RamRead" + CRLF);
			n = 0;
			sText = "";
			while (n<16) {
				sText += " " + string.Format("{0:X02}", Buff[n]);
				n++;
			}

			Memo.AppendText(sText+CRLF);
			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnMemWrite_Click(object sender, System.EventArgs e)
		{
			byte[] Buff = new byte[16]; // bufor na dane do zapisu
			string sText; // linia tekstu
			byte n, k; // zmienne pomocnicze

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla zapisu do pamici TeleTokenu
			//---------------------------------------
			n = 0;
			Memo.AppendText(CRLF + "MemWrite" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_NV_MEM_SIZE]) {
				// wypenienie bufora przykadowymi wartociami
				TeleTokenAPI.TVTTAPI_Rand(ref Buff);

				// zapis bufora do pamici
				TeleTokenAPI.TVTTAPI_MemWrite(Pass, GCon, n, Buff);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("MemWrite error" + CRLF +
						"--------------------" + CRLF);
					CloseSession();
					return;
				}

				// wywietlenie danych zapisanych do pamici
				k = 0;
				sText = "";
				while (k<16) {
					sText += " " + string.Format("{0:X02}", Buff[k]);
					k++;
				}
				Memo.AppendText(sText+CRLF);

				// zwikszenie licznika sektorw
				n++;
			}
			//---------------------------------------

			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}
		
		private void btnMemRead_Click(object sender, System.EventArgs e)
		{
			byte[] Buff = new byte[16]; // bufor na odczytane dane
			string sText; // linia tekstu
			byte n, k; // zmienne pomocnicze

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla odczytu z pamici TeleTokenu
			//---------------------------------------
			n = 0;
			Memo.AppendText(CRLF + "MemRead" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_NV_MEM_SIZE]) {
				// odczyt z pamici
				TeleTokenAPI.TVTTAPI_MemRead(Pass, GCon, n, ref Buff);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("MemRead error" + CRLF +
						"--------------------" + CRLF);
					CloseSession();
				}

				// wywietlenie danych odczytanych z pamici
				k = 0;
				sText = "";
				while (k<16) {
					sText += " " + string.Format("{0:X02}", Buff[k]);
					k++;
				}
				Memo.AppendText(sText+CRLF);

				// zwikszenie licznika sektorw
				n++;
			}
			//---------------------------------------

			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnMemWriteProtect_Click(object sender, System.EventArgs e)
		{
			byte[] Buff = new byte[16]; // bufor na dane do zapisu
			string sText; // linia tekstu
			byte n, k; // zmienne pomocnicze

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla zapisu do pamici TeleTokenu
			//---------------------------------------
			n = 0;
			Memo.AppendText(CRLF + "MemWriteProtect" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_PROTECT_MEM_SIZE]) {
				// wypenienie bufora przykadowymi wartociami
				TeleTokenAPI.TVTTAPI_Rand(ref Buff);

				// zapis bufora do pamici
				TeleTokenAPI.TVTTAPI_MemWriteProtect(Pass, GCon, n, Buff);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("MemWriteProtect error" + CRLF +
						"--------------------" + CRLF);
					CloseSession(); // zamknicie sesji
					return;
				}

				// wywietlenie danych zapisanych do pamici
				k = 0;
				sText = "";
				while (k<16) {
					sText += " " + string.Format("{0:X02}", Buff[k]);
					k++;
				}
				Memo.AppendText(sText+CRLF);

				// zwikszenie licznika sektorw
				n++;
			}
			//---------------------------------------

			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnMemProtect_Click(object sender, System.EventArgs e)
		{
			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla zabezpieczajca zapis do sektorw TeleTokenu
			//---------------------------------------
			byte n = 0;
			Memo.AppendText(CRLF + "MemProtect" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_PROTECT_MEM_SIZE]) {
				// zabezpieczenie zapisu do pamici sektora n
				TeleTokenAPI.TVTTAPI_MemProtect(Pass, GCon, n);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("MemProtect error" + CRLF +
						"--------------------" + CRLF);
					CloseSession(); // zamknicie sesji
					return;
				}

				// zwikszenie licznika sektorw
				n++;
			}
			//---------------------------------------

			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnCntWrite_Click(object sender, System.EventArgs e)
		{
			byte n; // zmienna pomocnicza
			string sText;

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla zapisu wartoci licznikw
			//---------------------------------------
			n = 0;
			sText = "";
			Memo.AppendText(CRLF + "CounterWrite" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_COUNTERS]) {
				// zapis wartoci licznika
				TeleTokenAPI.TVTTAPI_CounterWrite(Pass, GCon, n, (uint)(0x55+n));

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("CounterWrite error" + CRLF +
						"--------------------" + CRLF);
					CloseSession(); // zamknicie sesji
					return;
				}
				sText += " " + string.Format("{0:X02}", 0x55+n);

				// zwikszenie wartoci licznika ptli
				n++;
			}
			//---------------------------------------

			Memo.AppendText(sText+CRLF);
			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnCntRead_Click(object sender, System.EventArgs e)
		{
			byte n; // zmienna pomocnicza
			uint cnt; // warto licznika
			string sText;

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla odczytu wartoci licznikw
			//---------------------------------------
			n = 0;
			sText = "";
			Memo.AppendText(CRLF + "CounterRead" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_COUNTERS]) {
				// odczyt wartoci licznikw
				cnt = TeleTokenAPI.TVTTAPI_CounterRead(Pass, GCon, n);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("CounterRead error" + CRLF +
						"--------------------" + CRLF);
					CloseSession(); // zamknicie sesji
					return;
				}
				sText += " " + string.Format("{0:X02}", cnt);

				// zwikszenie wartoci licznika ptli
				n++;
			}
			//---------------------------------------

			Memo.AppendText(sText+CRLF);
			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}
		
		private void btnCntIncRead_Click(object sender, System.EventArgs e)
		{
			byte n; // zmienna pomocnicza
			uint cnt; // warto licznika
			string sText;

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla zwikszajca i odczytujca wartoci
			// licznikw
			//---------------------------------------
			n = 0;
			sText = "";
			Memo.AppendText(CRLF + "CounterIncRead" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_COUNTERS]) {
				// zwikszenie i odczyt wartoci licznika
				cnt = TeleTokenAPI.TVTTAPI_CounterIncRead(Pass, GCon, n);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
				  Memo.AppendText("CounterIncRead error" + CRLF +
					"--------------------" + CRLF);
				  CloseSession(); // zamknicie sesji
				  return;
				}

				sText += " " + string.Format("{0:X02}", cnt);

				// zwikszenie wartoci licznika ptli
				n++;
			}
			//---------------------------------------

			Memo.AppendText(sText+CRLF);
			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnCntDecRead_Click(object sender, System.EventArgs e)
		{
			byte n; // zmienna pomocnicza
			uint cnt; // warto licznika
			string sText;

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla zwikszajca i odczytujca wartoci
			// licznikw
			//---------------------------------------
			n = 0;
			sText = "";
			Memo.AppendText(CRLF + "CounterDecRead" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_COUNTERS]) {
				// zmniejszenie i odczyt wartoci licznika
				cnt = TeleTokenAPI.TVTTAPI_CounterDecRead(Pass, GCon, n);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
				  Memo.AppendText("CounterDecRead error" + CRLF +
					"--------------------" + CRLF);
				  CloseSession(); // zamknicie sesji
				  return;
				}

				sText += " " + string.Format("{0:X02}", cnt);

				// zwikszenie wartoci licznika ptli
				n++;
			}
			//---------------------------------------

			Memo.AppendText(sText+CRLF);
			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnCntIncEncRead_Click(object sender, System.EventArgs e)
		{
			byte[] Buff = new byte[16]; // bufor na dane
			byte[] Buf2 = new byte[16]; // bufor na odszyfrowane dane
			string sText; // linia tekstu
			byte n, k; // zmienne pomocnicza

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla zwikszajca i odczytujca wartoci
			// licznikw w postaci zaszyfrowanej
			//---------------------------------------
			n = 0;
			sText = "";
			Memo.AppendText(CRLF + "CounterIncEncryptRead" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_COUNTERS]) {
				// zwikszenie i odczyt zaszyfrowanej wartoci licznika
				TeleTokenAPI.TVTTAPI_CounterIncEncryptRead(Pass, GCon, n, n,
					ref Buff);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("CounterIncEncryptRead error" + CRLF +
						"--------------------" + CRLF);
					CloseSession(); // zamknicie sesji
					return;
				}

				// wywietlenie zaszyfrowanych wartoci zwrconych przez funkcje
				k = 0;
				sText = "";
				while (k<16) {
					sText += " " + string.Format("{0:X02}", Buff[k]);
					k++;
				}
				Memo.AppendText(sText);

				// rozszyfrowanie i wywietlenie
				rijndael.rijndaelDecrypt(GlobalDef.PassTbl[n], ref Buff);
				Memo.AppendText(string.Format(" : {0:X02}", Buff[1]));
				Memo.AppendText(string.Format(" {0:X02}", Buff[0]) + CRLF);

				// zwikszenie wartoci licznika ptli
				n++;
			}
			//---------------------------------------

			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnCntConfigWrite_Click(object sender, System.EventArgs e)
		{
			byte n, // zmienna pomocnicza
			Config0, Config1; // zmienne dla konfiguracji licznikw

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla zapisujca konfiguracje licznikw
			//---------------------------------------
			n = 0;
			Memo.AppendText(CRLF + "CounterConfigWrite" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_COUNTERS]) {
				// konfiguracja licznikw
				Config0 = TeleToken.TVTTCC0_WRITE | TeleToken.TVTTCC0_READ |
					TeleToken.TVTTCC0_INC_READ | TeleToken.TVTTCC0_DEC_READ |
					TeleToken.TVTTCC0_INC_ENCRYPT_READ |
					TeleToken.TVTTCC0_STOP_AT_ZERO |
					TeleToken.TVTTCC0_NVMEM_READ |
					TeleToken.TVTTCC0_NVMEM_WRITE;
				Config1 = TeleToken.TVTTCC1_PASS |
					TeleToken.TVTTCC1_CONFIG_ENABLED;

				// zapis konfiguracji
				TeleTokenAPI.TVTTAPI_CounterConfigWrite(Pass, GCon, n, Config0,
					Config1);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("CounterConfigWrite error" + CRLF +
						"--------------------" + CRLF);
					CloseSession(); // zamknicie sesji
					return;
				}

				// zwikszenie wartoci licznika ptli
				n++;
			}
			//---------------------------------------

			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}
		
		private void btnCntConfigSet_Click(object sender, System.EventArgs e)
		{
			byte n, // zmienna pomocnicza
			Config0, Config1; // zmienne dla konfiguracji licznikw

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla ustawiajca bity konfiguracji licznikw
			// (wszystkie wczone)
			//---------------------------------------
			n = 0;
			Memo.AppendText(CRLF + "CounterConfigSet" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_COUNTERS]) {
				// ustawienie bitw konfiguracyjnych
				Config0 = TeleToken.TVTTCC0_WRITE | TeleToken.TVTTCC0_READ |
					TeleToken.TVTTCC0_INC_READ | TeleToken.TVTTCC0_DEC_READ |
					TeleToken.TVTTCC0_INC_ENCRYPT_READ |
					TeleToken.TVTTCC0_STOP_AT_ZERO |
					TeleToken.TVTTCC0_NVMEM_READ |
					TeleToken.TVTTCC0_NVMEM_WRITE;
				Config1 = TeleToken.TVTTCC1_PASS |
					TeleToken.TVTTCC1_CONFIG_ENABLED;

				// przesanie do TeleTokenu bitw konfiguracji do ustawienia
				TeleTokenAPI.TVTTAPI_CounterConfigSet(Pass, GCon, n, Config0,
					Config1);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("CounterConfigSet error" + CRLF +
						"--------------------" + CRLF);
					CloseSession(); // zamknicie sesji
					return;
				}

				// zwikszenie wartoci licznika ptli
				n++;
			}
			//---------------------------------------

			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnCntConfigClear_Click(object sender, System.EventArgs e)
		{
			byte n, // zmienna pomocnicza
			Config0, Config1; // zmienne dla konfiguracji licznikw

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla zerujca bity konfiguracji licznikw
			// (wszystkie wyczone)
			//---------------------------------------
			n = 0;
			Memo.AppendText(CRLF + "CounterConfigClear" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_COUNTERS]) {
				// bity konfiguracji do wyzerowania
				Config0 = TeleToken.TVTTCC0_WRITE | TeleToken.TVTTCC0_READ |
					TeleToken.TVTTCC0_INC_READ | TeleToken.TVTTCC0_DEC_READ |
					TeleToken.TVTTCC0_INC_ENCRYPT_READ |
					TeleToken.TVTTCC0_STOP_AT_ZERO |
					TeleToken.TVTTCC0_NVMEM_READ |
					TeleToken.TVTTCC0_NVMEM_WRITE;
				Config1 = TeleToken.TVTTCC1_PASS |
					TeleToken.TVTTCC1_CONFIG_ENABLED;

				// przesanie do TeleTokenu bitw konfiguracji do wyzerowania
				TeleTokenAPI.TVTTAPI_CounterConfigClear(Pass, GCon, n, Config0,
					Config1);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("CounterConfigClear error" + CRLF +
						"--------------------" + CRLF);
					CloseSession(); // zamknicie sesji
					return;
				}

				// zwikszenie wartoci licznika ptli
				n++;
			}
			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnPassWrite_Click(object sender, System.EventArgs e)
		{
			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla zapisujca hasa do TeleTokenu
			//---------------------------------------
			byte n = 0; // zmienna pomocnicza
			Memo.AppendText(CRLF + "PassWrite" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_PASS_TABLE_SIZE]) {
				// zapis hase do TeleTokenu
				TeleTokenAPI.TVTTAPI_PassWrite(Pass, GCon, n, GlobalDef.PassTbl[n]);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("PassWrite error" + CRLF +
						"--------------------" + CRLF);
					CloseSession(); // zamknicie sesji
					return;
				}

				// zwikszenie licznika ptli
				n++;
			}
			//---------------------------------------

			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnPassConfigWrite_Click(object sender, System.EventArgs e)
		{
			byte Config0, Config1; // zmienne dla konfiguracji licznikw

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla zapisujca konfiguracje hase do TeleTokenu
			//---------------------------------------
			byte n = 0; // zmienna pomocnicza
			Memo.AppendText(CRLF + "PassConfigWrite" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_PASS_TABLE_SIZE]) {
				// konfiguracja bitw hase
				Config0 = TeleToken.TVTTPC0_TOKEN |
					TeleToken.TVTTPC0_PASS_WRITE |
					TeleToken.TVTTPC0_PASS_CONFIG |
					TeleToken.TVTTPC0_MEM_READ | TeleToken.TVTTPC0_MEM_WRITE |
					TeleToken.TVTTPC0_ENCRYPT | TeleToken. TVTTPC0_DECRYPT;
				Config1 = TeleToken.TVTTPC1_CNT_READ |
					TeleToken.TVTTPC1_CNT_WRITE | TeleToken.TVTTPC1_CNT_CONFIG |
					TeleToken.TVTTPC1_ENCRYPT_PASS |
					TeleToken. TVTTPC1_DECRYPT_PASS |
					TeleToken. TVTTPC1_CNT_ENCRYPT_PASS |
					TeleToken. TVTTPC1_WRITE_ENABLED |
					TeleToken. TVTTPC1_CONFIG_ENABLED;

				// przesanie do TeleTokenu bitw konfiguracji hase
				TeleTokenAPI.TVTTAPI_PassConfigWrite(Pass, GCon, n, Config0,
					Config1);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("PassConfigWrite error" + CRLF +
						"--------------------" + CRLF);
					CloseSession(); // zamknicie sesji
					return;
				}

				// zwikszenie licznika ptli
				n++;
			}
			//---------------------------------------

			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnPassConfigSet_Click(object sender, System.EventArgs e)
		{
			byte n, // zmienna pomocnicza
			Config0, Config1; // zmienne dla konfiguracji licznikw

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla ustawiajca bity konfiguracji hase TeleTokenu
			//---------------------------------------
			n = 0;
			Memo.AppendText(CRLF + "PassConfigSet" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_PASS_TABLE_SIZE]) {
				// konfiguracja bitw hase
				Config0 = TeleToken.TVTTPC0_TOKEN |
					TeleToken.TVTTPC0_PASS_WRITE |
					TeleToken.TVTTPC0_PASS_CONFIG | TeleToken.TVTTPC0_MEM_READ |
					TeleToken.TVTTPC0_MEM_WRITE | TeleToken.TVTTPC0_ENCRYPT |
					TeleToken.TVTTPC0_DECRYPT;
				Config1 = TeleToken.TVTTPC1_CNT_READ |
					TeleToken.TVTTPC1_CNT_WRITE | TeleToken.TVTTPC1_CNT_CONFIG |
					TeleToken.TVTTPC1_ENCRYPT_PASS |
					TeleToken.TVTTPC1_DECRYPT_PASS |
					TeleToken.TVTTPC1_CNT_ENCRYPT_PASS |
					TeleToken.TVTTPC1_WRITE_ENABLED |
					TeleToken. TVTTPC1_CONFIG_ENABLED;

				// przesanie do TeleTokenu bitw konfiguracji hase do ustawienia
				TeleTokenAPI.TVTTAPI_PassConfigSet(Pass, GCon, n, Config0,
					Config1);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("PassConfigSet error" + CRLF +
						"--------------------" + CRLF);
					CloseSession(); // zamknicie sesji
					return;
				}

				// zwikszenie licznika ptli
				n++;
			}
			//---------------------------------------

			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnPassConfigClear_Click(object sender, System.EventArgs e)
		{
			byte n, // zmienna pomocnicza
			Config0, Config1; // zmienne dla konfiguracji licznikw

			// otwarcie sesji
			if (OpenSession() != 0) return;

			// ptla zerujca bity konfiguracji hase TeleTokenu
			//---------------------------------------
			n = 0;
			Memo.AppendText(CRLF + "PassConfigClear" + CRLF);
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_PASS_TABLE_SIZE]) {
				// konfiguracja bitw hase
				Config0 = TeleToken.TVTTPC0_TOKEN |
					TeleToken.TVTTPC0_PASS_WRITE |
					TeleToken.TVTTPC0_PASS_CONFIG | TeleToken.TVTTPC0_MEM_READ |
					TeleToken.TVTTPC0_MEM_WRITE | TeleToken.TVTTPC0_ENCRYPT |
					TeleToken.TVTTPC0_DECRYPT;
				Config1 = TeleToken.TVTTPC1_CNT_READ |
					TeleToken.TVTTPC1_CNT_WRITE | TeleToken.TVTTPC1_CNT_CONFIG |
					TeleToken.TVTTPC1_ENCRYPT_PASS |
					TeleToken.TVTTPC1_DECRYPT_PASS |
					TeleToken.TVTTPC1_CNT_ENCRYPT_PASS |
					TeleToken.TVTTPC1_WRITE_ENABLED |
					TeleToken.TVTTPC1_CONFIG_ENABLED;

				// przesanie do TeleTokenu bitw konfiguracji hase do wyzerowania
				TeleTokenAPI.TVTTAPI_PassConfigClear(Pass, GCon, n, Config0,
					Config1);

				// obsuga bdw
				Status = TeleToken.GetLastError();
				if (GlobErr.CheckErr(Status) != 0) {
					Memo.AppendText("PassConfigClear error" + CRLF +
						"--------------------" + CRLF);
					CloseSession(); // zamknicie sesji
					return;
				}

				// zwikszenie licznika ptli
				n++;
			}
			//---------------------------------------

			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnEncrypt_Click(object sender, System.EventArgs e)
		{
			byte n, k;
			string sText;

			// otwarcie sesji
			if (OpenSession() != 0) return;

			//wywietlenie informacji o danych wejciowych
			Memo.AppendText(CRLF + "Encrypt" + CRLF);
			sText = "Test crypt....  ";
			for (n=0; n<sText.Length; n++) CryptBuff[n] = (byte)sText[n];
			sText = CRLF + "Input ASCII:" + CRLF + CRLF + sText + CRLF;
			Memo.AppendText(sText + CRLF);
			Memo.AppendText("Input HEX:" + CRLF + CRLF);
			k = 0;
			sText = "";
			while (k<16) {
				sText += " " + string.Format("{0:X02}", CryptBuff[k]);
				k++;
			}
			Memo.AppendText(sText+CRLF);

			// szyfrowanie bloku TeleTokenem przy uyciu pierwszego hasa
			TeleTokenAPI.TVTTAPI_Encrypt(Pass, GCon, 1, ref CryptBuff);

			// obsuga bdw
			Status = TeleToken.GetLastError();
			if (GlobErr.CheckErr(Status) != 0) {
				Memo.AppendText("Encrypt error" + CRLF +
					"--------------------" + CRLF);
				CloseSession(); // zamknicie sesji
				return;
			}

			// wywietlenie zaszyfrowanego bloku
			Memo.AppendText(CRLF + "Output HEX:" + CRLF + CRLF);
			k = 0;
			sText = "";
			while (k<16) {
				sText += " " + string.Format("{0:X02}", CryptBuff[k]);
				k++;
			}
			Memo.AppendText(sText+CRLF+CRLF);
			Memo.AppendText(cOK+CRLF);

			// zamknicie sesji
			CloseSession();
		}

		private void btnDecrypt_Click(object sender, System.EventArgs e)
		{
			byte n,k;
			string sText;

			// otwarcie sesji
			if (OpenSession() != 0) return;

			//wywietlenie informacji o danych wejciowych
			k = 0;
			sText = "";
			Memo.AppendText(CRLF + "Decrypt" + CRLF + CRLF);
			Memo.AppendText("Input HEX:" + CRLF + CRLF);
			while (k<16) {
				sText += " " + string.Format("{0:X02}", CryptBuff[k]);
				k++;
			}
			Memo.AppendText(sText+CRLF);

			// deszyfrowanie bloku przy uyciu pierwszego hasa
			TeleTokenAPI.TVTTAPI_Decrypt(Pass, GCon, 1, ref CryptBuff);

			// obsuga bdw
			Status = TeleToken.GetLastError();
			if (GlobErr.CheckErr(Status) != 0) {
				Memo.AppendText("Decrypt error" + CRLF +
					"--------------------" + CRLF);
				CloseSession(); // zamknicie sesji
			}

			// wywietlenie danych wyjciowych
			Memo.AppendText(CRLF + "Output HEX:" + CRLF + CRLF);
			k = 0;
			sText = "";
			while (k<16) {
				sText += " " + string.Format("{0:X02}", CryptBuff[k]);
				k++;
			}
			Memo.AppendText(sText+CRLF);

			sText = "";
			for (n=0; n<16; n++) sText += (char)(CryptBuff[n]);
			sText = CRLF + "Output ASCII:" + CRLF + CRLF + sText + CRLF;

			Memo.AppendText(sText+CRLF);
			Memo.AppendText(cOK+CRLF);

			// zakoczenie sesji
			CloseSession();
		}

		private void btnEncryptBlock_Click(object sender, System.EventArgs e)
		{
			string sErr, FName;
			uint n, FSize, OutSize = 0;
			FileStream fsin, fsout;
			BinaryReader inb;
			BinaryWriter outb;
			byte[] Buf;

			sErr = "EncryptBlock error" + CRLF + "--------------------";
			Memo.AppendText(CRLF + "EncryptBlock" + CRLF);

			// otwarcie okna dialogu
			if (OpenDlg.ShowDialog() != DialogResult.OK) {
				Memo.AppendText(sErr+CRLF);
				return;
			}

			// otwarcie pliku zrodlowego
			try {
				fsin = new FileStream(OpenDlg.FileName, FileMode.Open);
			} catch {
				Memo.AppendText(sErr+CRLF);
				return;
			}
			inb = new BinaryReader(fsin);

			// otwarcie pliku docelowego (zakodowanego)
			FName = OpenDlg.FileName + ".crp";
			try {
				fsout = new FileStream(FName, FileMode.Create);
			} catch {
				Memo.AppendText(sErr);
				inb.Close();
				fsin.Close();
				return;
			}
			outb = new BinaryWriter(fsout);

			// otwarcie sesji
			if (OpenSession() != 0) {
				inb.Close();
				outb.Close();
				fsin.Close();
				fsout.Close();
				return;
			}

			// odczyt pliku do zaszyfrowania
			FSize = (uint)fsin.Length;
			Buf = new byte[TeleTokenAPI.TVTTAPI_EncryptBlockSize(FSize)];
			for (n=0; n<FSize; n++) Buf[n] = inb.ReadByte();

			// szyfrowanie bloku danych TeleTokenem
			TeleTokenAPI.TVTTAPI_EncryptBlock(Pass, GCon, 1, ref Buf, FSize,
				ref OutSize);

			// obsuga bdw
			Status = TeleToken.GetLastError();
			if (GlobErr.CheckErr(Status) != 0)
				Memo.AppendText(sErr+CRLF);
			else
				// zapis zaszyfrowanych danych do pliku
				outb.Write(Buf, 0, (int)OutSize);

			// zamknicie plikw
			inb.Close();
			outb.Close();
			fsin.Close();
			fsout.Close();

			Memo.AppendText(cOK+CRLF);

			// zakoczenie sesji
			CloseSession();
		}
		
		private void btnDecryptBlock_Click(object sender, System.EventArgs e)
		{
			string sErr, FName;
			uint FSize, OutSize = 0;
			FileStream fsin, fsout;
			BinaryReader inb;
			BinaryWriter outb;
			byte[] Buf;

			sErr = "DecryptBlock error" + CRLF + "--------------------";
			Memo.AppendText(CRLF + "DecryptBlock" + CRLF);

			// otwarcie okna dialogu
			OpenDlg.Filter = "Encrypt files (*.crp)|*.CRP";
			if (OpenDlg.ShowDialog() != DialogResult.OK) {
				Memo.AppendText(sErr+CRLF);
				return;
			}

			// otwarcie pliku rda
			try {
				fsin = new FileStream(OpenDlg.FileName, FileMode.Open);
			} catch {
				Memo.AppendText(sErr+CRLF);
				return;
			}
			inb = new BinaryReader(fsin);

			// otwarcie pliku docelowego (zdekodowanego)
			FName = OpenDlg.FileName + ".dcrp";
			try {
				fsout = new FileStream(FName, FileMode.Create);
			} catch {
				Memo.AppendText(sErr+CRLF);
				inb.Close();
				fsin.Close();
				return;
			}
			outb = new BinaryWriter(fsout);

			// otwarcie sesji
			if (OpenSession() != 0) {
				inb.Close();
				outb.Close();
				fsin.Close();
				fsout.Close();
				return;
			}

			// odczyt pliku do odszyfrowania
			FSize = (uint)fsin.Length;
			Buf = inb.ReadBytes((int)FSize);

			//odszyfrowanie pliku
			TeleTokenAPI.TVTTAPI_DecryptBlock(Pass, GCon, 1, ref Buf,
				ref OutSize);

			// obsuga bdw
			Status = TeleToken.GetLastError();
			if (GlobErr.CheckErr(Status) != 0)
				Memo.AppendText(sErr+CRLF);
			else
				// zapis zaszyfrowanych danych do pliku
				outb.Write(Buf, 0, (int)OutSize);

			// zamknicie plikw
			inb.Close();
			outb.Close();
			fsin.Close();
			fsout.Close();

			Memo.AppendText(cOK+CRLF);

			// zakoczenie sesji
			CloseSession();
		}

		private void btnRand_Click(object sender, System.EventArgs e)
		{
			byte[] tRandom = new byte[16];
			byte n;

			// generowanie liczb pseudolosowych
			TeleTokenAPI.TVTTAPI_Rand(ref tRandom);

			// wywietlenie wygenerowanych liczb
			for (n=0; n<16; n++)
				Memo.AppendText(string.Format("{0:X02} ", tRandom[n]));
			Memo.AppendText(CRLF);
		}

		protected override void WndProc(ref Message m)
		{
			base.WndProc(ref m);
			TeleTokenAPI.TVTTAPI_Randomize(m);
		}
	}
}
